"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isForStatement = void 0;
const renderHelpers_1 = require("../../utils/renderHelpers");
const BlockScope_1 = __importDefault(require("../scopes/BlockScope"));
const NodeType = __importStar(require("./NodeType"));
const Node_1 = require("./shared/Node");
function isForStatement(node) {
    return node.type === NodeType.ForStatement;
}
exports.isForStatement = isForStatement;
class ForStatement extends Node_1.StatementBase {
    createScope(parentScope) {
        this.scope = new BlockScope_1.default(parentScope);
    }
    hasEffects(options) {
        return ((this.init && this.init.hasEffects(options)) ||
            (this.test && this.test.hasEffects(options)) ||
            (this.update && this.update.hasEffects(options)) ||
            this.body.hasEffects(options.setIgnoreBreakStatements()));
    }
    render(code, options) {
        if (this.init)
            this.init.render(code, options, renderHelpers_1.NO_SEMICOLON);
        if (this.test)
            this.test.render(code, options, renderHelpers_1.NO_SEMICOLON);
        if (this.update)
            this.update.render(code, options, renderHelpers_1.NO_SEMICOLON);
        this.body.render(code, options);
    }
}
exports.default = ForStatement;
